package com.ghomerr.linkedchest.enums;

import java.util.HashMap;
import java.util.HashSet;
import java.util.logging.Logger;

import org.bukkit.command.CommandExecutor;
import org.bukkit.command.PluginCommand;
import org.bukkit.plugin.java.JavaPlugin;

import com.ghomerr.linkedchest.constants.Constants;

public enum Commands
{
	ADD(new String[] {"ad", "add"}),
	
	ADMIN_CHEST(new String[] {"ac", "achest", "admin", "admchest", "adminchest"}, "a"),
	
	ALIASES(new String[] {"al", "alias", "aliases"}),
	
	CONFIG(new String[] {"cf", "conf", "config", "configuration"}),
	
	DEBUG(new String[] {"db", "debug"}),
	
	DETAILS(new String[] {"dt", "det", "detail", "details"}),
	
	HELP(new String[] {"hp", "help"}),
	
	LINKED_CHEST(new String[] {"lc", "lchest", "linkchest", "linkedchest"}),
	
	LIST(new String[] {"ls", "li", "list", "liste"}),
	
	OPEN(new String[] {"op", "open"}),
	
	USE_PERMISSIONS(new String[] {"pr", "perm", "perms", "useperm", "useperms", "usepermission", "usepermissions"}),
	
	REMOVE(new String[] {"rm", "dl", "rem", "del", "remove", "delete"});
	
	private static final Logger _LOGGER = Logger.getLogger(Constants.MINECRAFT);
	
	public static HashMap<String, Commands> commands = new HashMap<String, Commands>();
	
	public HashSet<String> list;
	public String option;
	
	Commands(final String[] tab)
	{
		list = new HashSet<String>();
		for (String cmd : tab)
		{
			list.add(cmd);
		}
	}
	
	static
	{
		for (final Commands cmd : Commands.values())
		{
			for (final String str : cmd.list)
			{
				commands.put(str, cmd);
			}
		}
	}
	
	Commands (final String[] tab, final String option)
	{
		this(tab);
		this.option = option;
	}

	public boolean has(final String cmd)
	{
		return list.contains(cmd.toLowerCase());
	}
	
	public boolean contains(final String optionList)
	{
		return optionList.contains(this.option);
	}
	
	public static void registerMainCommand(final JavaPlugin plugin, final CommandExecutor cmdExec)
	{
		for (final String cmd : Commands.LINKED_CHEST.list)
		{
			final PluginCommand pluginCmd = plugin.getCommand(cmd);
			if (pluginCmd != null)
			{
				pluginCmd.setExecutor(cmdExec);
			}
			else
			{
				_LOGGER.severe(Constants.TAG + "Command " + cmd + " could not be added.");
			}
		}
	}
}
