package com.ghomerr.linkedchest.objects;

import org.bukkit.Location;
import org.bukkit.inventory.Inventory;

import com.ghomerr.linkedchest.constants.Constants;
import com.ghomerr.linkedchest.enums.Commands;
import com.ghomerr.linkedchest.utils.StringUtils;

public class VirtualInventory
{
	public Inventory inventory = null;
	public Location location = null;
	public boolean isAdmin = false;
	
	public VirtualInventory(final Location loc, final boolean isAdmin)
	{
		super();
		this.location = loc;
		this.isAdmin = isAdmin;
		this.inventory = null;
	}
	
	public VirtualInventory(final Inventory inv, final Location loc, final boolean isAdmin)
	{
		this(loc, isAdmin);
		this.isAdmin = isAdmin;
	}
	
	public String getDataString()
	{
		final StringBuilder strBld = new StringBuilder();
		
		strBld.append(StringUtils.printShortLocation(location)).append(Constants.DELIMITER);
		if (isAdmin)
		{
			strBld.append(Commands.ADMIN_CHEST.option);
		}
		
		return strBld.toString();
	}
}
